﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
DataTable-Current-Verwaltung inkl. CurrentChanged-Event
Current kann man direkt setzen oder über die Synchronisation mit den dazu registrierten BindingSources - auch die Previous-Row ist abrufbar
Im Initialize-Event des typDatasets kann ParentNotification festgelegt werden, was bewirkt, dass der Current des DataTableAttachs der Parent-Table ggfs. nachgeführt wird, sodass zb. immer die richtige Kategorie zum angewählten Artikel eingestellt ist.
#End If
' -------------- Imports & Options --------------------
Imports System.Reflection
Imports System.ComponentModel
#End Region 'FileHeader

Namespace System.Data

   Partial Public Class DataTableAttach

      Public Event CurrentChanged As EventHandler
      Friend _ParentAttaches As New List(Of [Set](Of DataRelation, DataTableAttach))
      Private _Current As DataRow
      Public Previous As DataRow
      Private ReadOnly _CurrencyBindingsources As New List(Of BindingSource)

      Public Sub RegisterBindingSource(bs As BindingSource)
         _CurrencyBindingsources.Add(bs)
         _Current = bs.At
         InsertCurrentChangedHandler(bs, AddressOf bs_CurrentChanged)
      End Sub

      Public Sub SetParentNotifications(tables() As DataTable)
         Dim att0 = Me
         For Each itm In From tb In tables Select tb, tb.Attach, _
                         rl = att0.Table.ParentRelations.Cast(Of DataRelation).First(Function(r) r.ParentTable Is tb)
            att0._ParentAttaches.Add(New [Set](Of DataRelation, DataTableAttach)() With {.A = itm.rl, .B = itm.Attach})
            att0 = itm.Attach
         Next
      End Sub

      Public Shared EventsFieldInfo As FieldInfo = GetType(Component).GetField("events", BindingFlags.NonPublic Or BindingFlags.Instance)
      Private Shared _CurrentChangedKey As Object = GetType(BindingSource) _
         .GetField("EVENT_CURRENTCHANGED", BindingFlags.NonPublic Or BindingFlags.Static) _
         .GetValue(Nothing) ' That eventname is read from Rosylin or ILSpy etc.
      Private Shared Sub InsertCurrentChangedHandler(bs As BindingSource, handler As EventHandler)
         Dim events = DirectCast(EventsFieldInfo.GetValue(bs), EventHandlerList)
         Dim prevEvent = events(_CurrentChangedKey)
         Dim newEvent As [Delegate] = handler
         If prevEvent.NotNull Then
            For Each dlg In prevEvent.GetInvocationList
               newEvent = [Delegate].Combine(newEvent, dlg)
            Next
         End If
         events(_CurrentChangedKey) = newEvent
      End Sub

      Private Sub bs_CurrentChanged(sender As Object, e As EventArgs)
         If Not _IsBusy Then Current = DirectCast(sender, BindingSource).At
      End Sub
      Private _IsBusy As Boolean
      Public Property Current() As DataRow
         Get
            Return _Current
         End Get
         Set(value As DataRow)
            If value IsNot _Current Then SetCurrentCore(value)
         End Set
      End Property

      Private Sub SetCurrentCore(value As DataRow)
         If _IsBusy Then Throw Me.Exception("Während der Current-Aktualisierung kann Current nicht codeseitig geändert werden")
         Previous = _Current
         _Current = value
         If value.NotNull Then
            _IsBusy = True
            For Each itm In _ParentAttaches
               itm.B.Current = _Current.GetParentRow(itm.A)
            Next
            For Each bs In _CurrencyBindingsources
               Dim b = bs.MoveToRow(_Current)
            Next
            _IsBusy = False
         End If
         RaiseEvent CurrentChanged(Me, EventArgs.Empty)
      End Sub

      Public Sub SetInitialCurrent(rwInit As DataRow, raiseEventNow As Boolean)
         _Current = rwInit
         If raiseEventNow Then SetCurrentCore(rwInit) Else Previous = rwInit
      End Sub

   End Class
End Namespace
